--    Program: 		CAPAREXT_DISTRIBUTION_SET_LINE.sql
--    Description:  Extract AR Distribution Set Line information   
--    Revision:     1st     
--    Parameter: 	1. set of books short name e.g. SOB_C999

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

declare   
   l_processed_count		number;
   l_rejected_count 		number;
   l_err_msg				varchar2(2000);
                    		
   l_utl_file       		utl_file.file_type;
   l_filename       		varchar2(255);
   l_pathname       		varchar2(100);
                    		
   l_ngo_sob				varchar2(20);
   
   l_set_of_books_id		number;
                    		  
   cursor cur_dist_set_line (p_set_of_books_id number) is
      select adsl.* 
      from   ar_distribution_set_lines_all adsl,
             hr_organization_information hoi
	  where  hoi.org_information_context = 'Operating Unit Information'
	  and    hoi.org_information3 = to_char(p_set_of_books_id)
	  and    hoi.organization_id = adsl.org_id;

begin
   l_pathname := '/tmp';
   l_filename := 'CAPAR_DISTRIBUTION_SET_LINE.dat';
   l_utl_file := utl_file.fopen(l_pathname, l_filename, 'w');
   
   l_processed_count := 0;
   l_rejected_count  := 0;
   
   l_ngo_sob := '&1';
   
   begin
     select set_of_books_id
     into   l_set_of_books_id
     from   gl_sets_of_books
     where  upper(short_name) = upper(l_ngo_sob);
   exception
     when others then
       dbms_output.put_line(l_ngo_sob||': set of books name not found');
       --raise;
   end;      

   for cur in cur_dist_set_line(l_set_of_books_id) loop   	
     
     -- output data 
     utl_file.put_line( l_utl_file, 
       cur.DISTRIBUTION_SET_ID       || chr(9) ||
       cur.DIST_CODE_COMBINATION_ID  || chr(9) ||
       cur.SET_OF_BOOKS_ID           || chr(9) ||
       cur.LAST_UPDATE_DATE          || chr(9) ||
       cur.LAST_UPDATED_BY           || chr(9) ||
       cur.LAST_UPDATE_LOGIN         || chr(9) ||
       cur.CREATION_DATE             || chr(9) ||
       cur.CREATED_BY                || chr(9) ||
       cur.PERCENT_DISTRIBUTION      || chr(9) ||
       cur.DESCRIPTION               || chr(9) ||
       cur.ORG_ID 
	 );                        
                               
	 l_processed_count := l_processed_count + 1;
   end loop;

   if l_processed_count = 0 then   
     l_rejected_count := l_rejected_count + 1;
     l_err_msg := l_ngo_sob || ': AR distribution set line not found';
   end if;
   
   -- insert into log table
   insert into capcnv_log ( prog_id,process_date, record_processed,record_rejected,record_extracted,err_msg) 
    values ('CAPAREXT_DISTRIBUTION_SET_LINE', sysdate, l_processed_count, l_rejected_count, l_processed_count-l_rejected_count, l_err_msg );
   
   commit;

   utl_file.fclose(l_utl_file);
exception 
  when others then
    dbms_output.put_line(sqlerrm);
    rollback;  
end;
/

--exit
